angular.module('starter', ['ionic', 'starter.controllers', 'starter.user', 'ngCordova', 'sdw.filters', 'angular-json-tree'])

    .run(function ($ionicPlatform, $ionicPopup, LC, $rootScope, system, ws) {


        $rootScope.initStoredFormCount = function () {
            $rootScope.storedFormsCount = {};

            LC.get('savedforms').then(function (forms) {

                system.debug('initStoredFormCount', forms);

                for (form in forms) {
                    if (!angular.isDefined($rootScope.storedFormsCount[forms[form].id_nature])) {
                        $rootScope.storedFormsCount[forms[form].id_nature] = 0;
                    }
                    $rootScope.storedFormsCount[forms[form].id_nature] += 1;

                }
            });
        };

        $ionicPlatform.ready(function () {

            if (!angular.isDefined(window.localStorage['fetched'])) {
                window.localStorage['fetched'] = false;
            }

            LC.init().then(function () {
                $rootScope.initStoredFormCount();
                ws.getListNatures();
            });

            if (window.Connection && navigator.connection.type == Connection.NONE) {
                if (window.localStorage['fetched'] == false) {
                    $ionicPopup.confirm({
                        title:   "Pas d'accès internet",
                        content: "L'accès à internet est désactivé. Veuillez l'activer pour pourvoir utiliser l'application pour la première fois"
                    })
                        .then(function (result) {
                            if (!result) {
                                ionic.Platform.exitApp();
                            }
                        });
                } else {
                    // Connect remembered user if set
                    $rootScope.reconnect();
                }
            }

            if (window.cordova && window.cordova.plugins.Keyboard) {
                cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                cordova.plugins.Keyboard.disableScroll(true);

            }
            if (window.StatusBar) {
                StatusBar.styleDefault();
            }
        });
    })

    .config(function ($stateProvider, $urlRouterProvider, $ionicConfigProvider) {

        $ionicConfigProvider.scrolling.jsScrolling(false);

        $stateProvider
            .state('app', {
                url:         '/app',
                abstract:    true,
                templateUrl: 'templates/layout/menu.html'
                // controller:  'AppCtrl'
            })

            .state('app.home', {
                cache: false,
                url:   '/home',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/pages/home.html',
                        controller:  'AppCtrl'
                    }
                }
            })
            .state('app.nature', {
                cache: false,
                url:   '/nature/:natureId/:natureForm',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/pages/nature.html',
                        controller:  'NatureCtrl'
                    }
                }
            })
            .state('app.listForms', {
                cache: false,
                url:   '/list/:natureId',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/pages/listForms.html',
                        controller:  'ListFormsCtrl'
                    }
                }
            })
            .state('app.inscription', {
                cache: false,
                url:   '/inscription',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/user/inscription.html',
                        controller:  'InscriptionCtrl'
                    }
                }
            })
            .state('app.monCompte', {
                cache: false,
                url:   '/moncompte',
                views: {
                    'menuContent': {
                        templateUrl: 'templates/user/mon_compte.html',
                        controller:  'MonCompteCtrl'
                    }
                }
            });

        $urlRouterProvider.otherwise('/app/home');
    });
