angular.module('starter.controllers', ['sdw.tools', 'sdw.system', 'sdw.services', 'sdw.login', 'sdw.localstorage'])
    .controller('AppCtrl', function (
            $scope, $rootScope, $state, $cordovaDevice, $ionicHistory, $ionicPlatform, system, login, user, ws,
            LC, tools
        ) {

            $ionicHistory.clearHistory();

            $rootScope.settings = settings;

            if (!$rootScope.user)
                $rootScope.user = {};

            /**
             * init login system
             */

            login.initLogin();


            $rootScope.listCurrentForms = function (nature) {
                $rootScope.idnature = nature;
                system.forward($state, false, 'app.listForms', {"natureId": nature});
            };

            $scope.goback_b = function(){
                $ionicHistory.nextViewOptions({
                disableBack: false
            });
                $rootScope.plus = true ;
            };

            $rootScope.addFormToLocalStorage = function (nature, formId, name) {

                return LC.get('savedforms').then(function (forms) {

                    // system.debug('addFormToLocalStorage FORMS', forms);

                    var currentForm;
                    var now = Date.now();
                    if (name == 'undefined')
                        name = nature.titre + '_' + moment().format('DD/MM/YYYY');

                    if (forms === null || typeof forms == 'undefined') {
                        forms = [];

                        forms.push({
                            id:           nature.id_nature + "_" + now,
                            nature:       nature,
                            id_nature:    nature.id_nature,
                            creationDate: now,
                            name:         name,
                            updateDate:   now,
                            sent:         false
                        });
                    }

                    var updated = false;

                    for (var form in forms) {
                        if (forms[form].id == formId) {

                            // if (name == 'undefined')
                            //     name = nature.titre + '_' + moment().format('DD/MM/YYYY');
                            forms[form].nature = nature;
                            // forms[form].name = name;
                            forms[form].updateDate = now;
                            updated = true;
                            currentForm = forms[form];
                        }
                    }


                    // system.debug('addFormToLocalStorage CURRENT FORM', currentForm);
                    // system.debug('addFormToLocalStorage UPDATED', updated);

                    if (!updated) {
                        currentForm = {
                            id:           nature.id_nature + "_" + now,
                            nature:       nature,
                            id_nature:    nature.id_nature,
                            creationDate: now,
                            name:         name,
                            updateDate:   now,
                            sent:         false
                        };

                        forms.push(currentForm);
                    }

                    LC.set('savedforms', forms).then(function () {
                        $rootScope.initStoredFormCount();
                    });

                    return currentForm;
                });
            };

            $rootScope.markStoredFormAsSent = function (formId, sent) {
                LC.get('savedforms').then(function (forms) {
                    if (forms === null) {
                        forms = [];
                        LC.set('savedforms', []);
                    }

                    var now = Date.now();

                    var updated = false;

                    for (form in forms) {
                        if (forms[form].id == formId) {
                            forms[form].sent = sent;
                            forms[form].updateDate = now;
                            updated = true;
                        }
                    }

                    if (updated)
                        LC.set('savedforms', forms);
                });
            };

            $rootScope.showDeviceInfos = function () {
                system.alert('Infos', '<b>UUID: </b>' + settings.deviceUUID);
            };

            if ($rootScope.user === null) {
                system.forward($state, true, 'app.home');
            }
        }
    );
