angular.module('starter.controllers')
    .controller('NatureCtrl', function (
        $scope, $rootScope, $stateParams, $ionicScrollDelegate, $cordovaCamera, $state, $ionicHistory, user, ws, system,
        tools, LC, $timeout
    ) {
        $rootScope.askedFormName = false;

        $rootScope.sortAttributes = function (attribute) {
            return parseInt(attribute.sort);
        };

        $rootScope.sortPages = function (page) {
            return parseInt(page.sort);
        };

        $scope.etape = 1;

        $scope.saveForm = function () {

            function persistForm(formName) {
                $rootScope.addFormToLocalStorage($scope.nature, $scope.storedFormId, formName).then(function (form) {
                    $scope.storedFormId = form.id;
                    $scope.nature = form.nature;
                    $scope.natureForm = form;
                });
            }

            if (!tools.isDefined($scope.storedFormId)) {
                // Formulaire non sauvegardé en localStorage

                if (!$rootScope.askedFormName) {
                    // L'utilisateur est prié de saisir le nom du form
                    $rootScope.askedFormName = true;

                    system.ask('Personnaliser le nom du formulaire stocké ?', '', function (name) {
                        persistForm(name)
                    }, function () {
                        persistForm($scope.nature.titre + "_" + moment().format('DD/MM/YYYY'));
                    });


                } else {
                    // L'utilisateur à déjà été prié de saisir le nom du form
                    if ($scope.nature.name == '') {
                        // L'utilisateur est en train de remplir la popup
                    } else {
                        // L'utilisateur n'a pas choisis de nom
                    }
                }
            } else {
                // Formulaire sauvegardé en localStorage
                $rootScope.addFormToLocalStorage($scope.nature, $scope.storedFormId, $scope.nature.name).then(function (form) {
                    $scope.storedFormId = form.id;
                    $scope.nature = form.nature;
                    $scope.natureForm = form;

                    $ionicHistory.clearHistory();
                });
            }
        };


        $scope.checkAttributes = function () {

            var tabGlobalAttribute = [];

            for (numPage in $scope.nature.pages) {
                var page = $scope.nature.pages[numPage];

                for (numAttribute in page.attributes) {
                    var attribute = page.attributes[numAttribute];

                    tabGlobalAttribute[attribute.id_attribute] = {
                        "visible": attribute.visible,
                        "value":   attribute.value
                    };

                    var isVisibleEt, isVisibleOu, condition;

                    if (typeof attribute.conditions[0] !== 'undefined') {

                        isVisibleEt = true;
                        isVisibleOu = false;
                        for (numCondition in attribute.conditions) {
                            condition = attribute.conditions[numCondition];

                            if (condition.condition == 'et') {
                                isVisibleEt &= checkCondition(tabGlobalAttribute, condition);
                            }
                            else {
                                isVisibleOu |= checkCondition(tabGlobalAttribute, condition);
                            }
                        }

                        attribute.visible = isVisibleEt || isVisibleOu;
                        tabGlobalAttribute[attribute.id_attribute] = {
                            "visible": attribute.visible,
                            "value":   attribute.value
                        };
                    }

                    for (numValue in attribute.values) {
                        var value = attribute.values[numValue];

                        if (typeof value.conditions[0] !== 'undefined') {

                            isVisibleEt = true;
                            isVisibleOu = false;
                            for (numCondition in value.conditions) {
                                condition = value.conditions[numCondition];

                                if (condition.condition == 'et') {
                                    isVisibleEt &= checkCondition(tabGlobalAttribute, condition);
                                }
                                else {
                                    isVisibleOu |= checkCondition(tabGlobalAttribute, condition);
                                }
                            }
                            value.visible = isVisibleEt || isVisibleOu;
                        }
                    }
                }
            }

            $scope.saveForm();
        };

        $scope.$on('$ionicView.enter', function (viewInfo, state) {
            if (tools.isDefined($stateParams.natureForm) && $stateParams.natureForm !== null && $stateParams.natureForm !== '') {
                LC.getElement('savedforms', 'id', $stateParams.natureForm).then(function (form) {
                    $scope.nature = form.nature;
                    $scope.nature.name = form.nature.name;
                    $scope.storedFormId = form.id;
                    $scope.nbEtapes = $scope.nature.pages.length;
                    $scope.checkAttributes();

                });
            } else {
                $scope.storedFormId = null;
                if ($stateParams.natureId !== null) {
                    system.debug('GET CURRENT NATURE FROM WS', $stateParams.natureId);
                    ws.getNature($scope, $stateParams.natureId);
                }
            }
            system.debug('STATE PARAMS', $stateParams);
            if (tools.isDefined($stateParams.natureForm) && $stateParams.natureForm == '') {
                $scope.saveForm();
            }
        });

        $scope.nextStep = function ($event) {
            $timeout(function () {
                $event.stopImmediatePropagation();
                $event.stopPropagation();
                if ($scope.etape < $scope.nbEtapes + 1)
                    $scope.etape++;

                $scope.scrollToTop();
                $ionicScrollDelegate.resize();
                angular.element(document.querySelectorAll('.fake-input-to-remove-autofocus'))[0].focus();
            }, 500);


        };
        $scope.prevStep = function ($event) {
            $timeout(function () {
                $event.stopImmediatePropagation();
                $event.stopPropagation();
                if ($scope.etape > 1)
                    $scope.etape--;
                $scope.scrollToTop();
                angular.element(document.querySelectorAll('.fake-input-to-remove-autofocus'))[0].focus();
            }, 500);
        };

        $scope.goback = function(){
        if (!$rootScope.plus) {
         $state.go('app.listForms',{"natureId": $rootScope.idnature});
     }else if ($rootScope.plus) {
         $state.go('app.home', {reload:true});

     }
        };

        $scope.scrollToTop = function () {
            $ionicScrollDelegate.scrollTop(true);
        };

        $scope.sendForm = function () {

            system.confirm('Envoyer le formulaire ?', function () {

                if (system.isConnected()) {
                    ws.submitNature($scope, $scope.nature);
                    if (tools.isDefined($scope.storedFormId) && $scope.storedFormId !== null && $scope.storedFormId != '') {
                        $rootScope.markStoredFormAsSent($scope.storedFormId, true);
                    }
                }
                else
                    system.alert('Pas de connexion', 'Vous n\'etes pas connecté, enregistrement du formulaire', function () {
                        $scope.saveForm();
                    });
            });
        };

        $scope.getPhoto = function (attribute) {
            navigator.camera.getPicture(onSuccess, onFail, {
                quality:            90, targetWidth: 1024,
                targetHeight:       768, destinationType: 0,
                correctOrientation: true
            });

            function onSuccess(imageData) {
                attribute.value = "data:image/jpeg;base64," + imageData;
                $scope.$apply();
                $scope.saveForm();
            }

            function onFail(message) {
                alert('Erreur de la caméra: ' + message);
            }
        };

        function dataURItoBlob(dataURI) {
            var byteString = atob(dataURI.split(',')[1]);
            var mimeString = dataURI.split(',')[0].split(':')[1].split(';')[0];

            var ab = new ArrayBuffer(byteString.length);
            var ia = new Uint8Array(ab);
            for (var i = 0; i < byteString.length; i++) {
                ia[i] = byteString.charCodeAt(i);
            }

            return new Blob([ab], {"type": mimeString});
        }


        //Vérification de la condition en fonction du parent
        function checkCondition(tabGlobal, condition) {

            var valueReturn = false;

            if (condition.id_parent in tabGlobal && tabGlobal[condition.id_parent].visible) { // Si le parent existe et est visible
                var parent = tabGlobal[condition.id_parent];

                if (condition.operand === "=" && condition.value === parent.value) {
                    valueReturn = true;
                }
                else if (condition.operand === ">" && condition.value < parent.value) { //Check si la valeur du parent est supérieur à la condition
                    valueReturn = true;
                }
                else if (condition.operand === "<" && condition.value > parent.value) { //Check si la valeur du parent est inférieur à la condition
                    valueReturn = true;
                }
                else if (condition.operand === ">=" && condition.value <= parent.value) { //Check si la valeur du parent est supérieur ou égale à la condition
                    valueReturn = true;
                }
                else if (condition.operand === "<=" && condition.value >= parent.value) { //Check si la valeur du parent est inférieur ou égale à la condition
                    valueReturn = true;
                }
                else if (condition.operand === "!=" && condition.value != parent.value) { //Check si la valeur du parent est différente de la condition
                    valueReturn = true;
                }
                else if (condition.operand === "not null" && typeof parent.value !== "undefined" && parent.value != '' && parent.value !== null) {
                    valueReturn = true;
                }
                else {
                    valueReturn = false;
                }
            }
            else {
                valueReturn = false;
            }

            return valueReturn;
        }


    });
