angular.module('sdw.filters', [])
    .filter('toMoment', function () {
        return function (input, inputFormat, outputFormat, fromNow) {
            //moment.locale('fr-FR');

            moment.locale('fr', {
                calendar: {
                    sameDay:  '[Aujourd\'hui]',
                    nextDay:  '[Demain]',
                    nextWeek: 'dddd',
                    lastDay:  '[Hier]',
                    lastWeek: 'dddd [dernier]',
                    sameElse: 'DD MMMM'
                }
            });

            if (inputFormat == '') {
                inputFormat = null;
                input = input * 1000;
            }

            var dte = moment(input, inputFormat);

            if (angular.isDefined(fromNow))
                return dte.calendar();
            else
                return dte.format(outputFormat);
        };
    }).filter('cut', function () {
    return function (value, wordwise, max, tail) {
        if (!value) return '';

        max = parseInt(max, 10);
        if (!max) return value;
        if (value.length <= max) return value;

        value = value.substr(0, max);
        if (wordwise) {
            var lastspace = value.lastIndexOf(' ');
            if (lastspace != -1) {
                value = value.substr(0, lastspace);
            }
        }

        return value + (tail || ' …');
    };
}).filter('striphtml', function () {
    return function (text) {
        return text ? String(text).replace(/<[^>]+>/gm, '') : '';
    };
}).filter('sprintf', function () {

    function parse(str, args) {
        var i = 0;
        return str.replace(/%s/g, function () {
            return args[i++] || '';
        });
    }

    return function () {
        return parse(Array.prototype.slice.call(arguments, 0, 1)[0], Array.prototype.slice.call(arguments, 1));
    };
}).filter('capitalize', function () {
    return function (input) {
        if (!angular.isDefined(input))
            return '';

        if (input != null)
            input = input.toLowerCase();
        return input.substring(0, 1).toUpperCase() + input.substring(1);
    }
}).filter('toUpper', function () {
    return function (input) {
        if (angular.isDefined(input))
            return input.toUpperCase();
    };
})